# -*- coding: utf-8 -*-
"""
Copyright (c) 2016 Biuro Urządzania Lasu i Geodezji Leśnej

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), 
to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, 
and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:
The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, 
DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR 
OTHER DEALINGS IN THE SOFTWARE.
"""
from PyQt5 import QtGui
from PyQt5 import QtCore
from PyQt5.QtCore import *
from PyQt5.QtGui import *
from qgis.core import *
from qgis.gui import *

from Mapa_PU.kontroler import komunikaty,  warstwa
from Mapa_PU.widok.pasek_wiadomosci import PasekWiadomosc
import processing
     
class GenerujOddzialy(QObject):
    """Tworzenie oddziałów"""
    zakonczenie = QtCore.pyqtSignal(object)
    blad = QtCore.pyqtSignal(Exception, basestring)
    postep = QtCore.pyqtSignal(float)
    komunikat=QtCore.pyqtSignal('QString')
    
    def __init__(self,iface,mapa):
        """Constructor"""
        self.iface = iface
        self.mapa = mapa
        super(GenerujOddzialy,self).__init__()  # QObject.__init__()
            
    def showGenerujOddzialyDialog(self): 
        self.run()  
          
    def listaBezPowt(self,input_list,left=17):
        """ Lista unikatowych adresów lesnych ograniczona do 17 znaków z lewej strony bez powtórzeń.  Na wejsciu jest lista stringów oraz długosc pola od lewej strony. """
        for unqitem in set( [item[:left] for item in input_list] ):
            yield unqitem    
    
    #Liczba obiektów usuniętych z warstwy ODDZIAL:
    def usunRekordyZWarstwy(self):
        komunikaty.informacja(u"Generuj oddziały",u"Liczba obiektów usuniętych z warstwy ODDZIAL: " + str(self.warstwa_oddzial.kasujWszystkieObiekty()))
        
    
    def run(self):
        
        def wykAgregacja():
            """ funkcja pomocnicza uruchamia agregujWarstwe() """
            
            if (self.warstwa_o_podst.agregujWarstwe(self.warstwa_o_podst, self.warstwa_oddzial, nazwaPola='ADR_BDL',sufixPola='-    -' ,listaWartosciPola=lista_adresow_lesnych, pasekWiadomosc = PasekWiadomosc(self.iface,opis = u'Generowanie oddziałów') )):
                komunikaty.informacja(u"Generuj oddziały",u"Wygenerowano Oddziały w warstwie ODDZIAL")
                                
            else: 
                komunikaty.blad(u"Generuj oddziały", u"Nie udało sie tworzenie Oddziałów" )

        
        
        if QgsProject.instance().mapLayersByName('POW') and QgsProject.instance().mapLayersByName('ODDZIAL'): 
        #QgsMapLayerRegistry.instance().mapLayersByName('O_PODST') and QgsMapLayerRegistry.instance().mapLayersByName('ODDZIAL'):
            
            #self.warstwa_o_podst = self.mapa.warstwaRejestr('POW')
            #Naprawa warstwy O_PODST
            self.warstwa_o_podst=self.generujWarstwe(self.mapa.warstwaRejestr('O_PODST'))
            self.warstwa_oddzial = self.mapa.warstwaRejestr('ODDZIAL')
            
            adr_bdl_bool=any(elem.name()=='ADR_BDL' for elem in list(self.warstwa_o_podst.fields()))
            #pola=list(self.warstwa_o_podst.fields())

            #if pola[0].name()=='ADR_BDL':                    
            #if self.warstwa_o_podst.kontrolaObecnosciPola(nazwaPola='ADR_BDL'):
            if adr_bdl_bool:
                lista=[feature['ADR_BDL'] for feature in self.warstwa_o_podst.getFeatures()]
                lista_adresow_lesnych = list(self.listaBezPowt( lista ))
                
                if lista_adresow_lesnych :
                      
                    if (self.warstwa_oddzial.liczbaFeatureow() > 0):
                        
                        # Kasowanie w warstwie ODDZIAL #              
                        if not komunikaty.pytanie_usun_anuluj(u'Generuj oddziały',u'Czy usunąć obiekty z warstwy ODDZIAL ?'):
                            self.usunRekordyZWarstwy()
                            self.wypelnijWarstwe(self.warstwa_oddzial,self.warstwa_o_podst)
                            #wykAgregacja()
                    else:    
                        self.wypelnijWarstwe(self.warstwa_oddzial,self.warstwa_o_podst)
                        #wykAgregacja()
                                                       
                else:
                    komunikaty.blad(u"Generuj oddziały",u"Brak adresów leśnych w warstwie O_PODST !" )   
            else:
                komunikaty.blad(u"Generuj oddziały",u"Brak Pola ADR_BDL w Warstwie POW !")
        else:
            komunikaty.wiadomoscKrytyczna(self.iface,u"Proszę otworzyć wymagane pliki !",6)

            if not QgsProject.instance().mapLayersByName('O_PODST'):
                komunikaty.blad(u"Generuj oddziały",u"Brakuje warstwy O_PODST !")
                
            if not QgsProject.instance().mapLayersByName('ODDZIAL'):
                komunikaty.blad(u"Generuj oddziały",u"Brakuje warstwy ODDZIAL !") 
                
    def wypelnijWarstwe(self,wypelniana,dane):
        """Wypełnia warstwe na podstawie innej warstwy"""
        try:
            id=0
            for feature in dane.getFeatures():
                id+=1
                feat=QgsFeature(wypelniana.fields())
                feat.setAttribute('ADR_BDL',feature['ADR_BDL'])
                feat.setAttribute('ID',id)
                feat.setGeometry(feature.geometry())
                wypelniana.dataProvider().addFeature(feat)
            wypelniana.triggerRepaint()
            #self.mapa.odswierzMape()
            komunikaty.informacja(u"Generuj oddziały",u"Wygenerowano Oddziały w warstwie ODDZIAL")
        except Exception as e:
            raise e
        
    def generujWarstwe(self,layer:QgsMapLayer)->QgsVectorLayer:
        try:
            layer.selectAll()
            clone_layer = processing.run("native:saveselectedfeatures", {'INPUT': layer, 'OUTPUT': 'memory:'})['OUTPUT']
            layer.removeSelection()
            clone_layer.startEditing()
            [clone_layer.changeAttributeValue(feature.id(),feature.fieldNameIndex('ADR_BDL'),'{}    -'.format(feature['ADR_BDL'][0:18])) for feature in clone_layer.getFeatures()]
            clone_layer.commitChanges()
            
            gras=processing.run("grass7:v.dissolve", {'input':clone_layer,'column':'ADR_BDL','output':'TEMPORARY_OUTPUT','GRASS_REGION_PARAMETER':None,'GRASS_SNAP_TOLERANCE_PARAMETER':0.01,'GRASS_MIN_AREA_PARAMETER':0.0001,'GRASS_OUTPUT_TYPE_PARAMETER':0,'GRASS_VECTOR_DSCO':'','GRASS_VECTOR_LCO':'','GRASS_VECTOR_EXPORT_NOCAT':False})
            gras_layer=gras['output']
            #Naprawa geometrii
            fixed=processing.run("native:fixgeometries", {'INPUT':gras_layer,'OUTPUT':'TEMPORARY_OUTPUT'})
            #Łaczenie kawałków w multipolygon
            disolve_layer=processing.run("native:dissolve", {'INPUT':fixed['OUTPUT'],'FIELD':['ADR_BDL'],'OUTPUT':'TEMPORARY_OUTPUT'})
            return disolve_layer['OUTPUT']
            #gdal=processing.run("gdal:dissolve", {'INPUT':gras_layer,'FIELD':'ADR_BDL','GEOMETRY':'geometry','EXPLODE_COLLECTIONS':False,'KEEP_ATTRIBUTES':False,'COUNT_FEATURES':False,'COMPUTE_AREA':False,'COMPUTE_STATISTICS':False,'STATISTICS_ATTRIBUTE':'','OPTIONS':'','OUTPUT':'TEMPORARY_OUTPUT'})
            #gdal_layer=gdal['OUTPUT']
            #saga=processing.run("saga:polygondissolvebyattribute", {'POLYGONS':gras_layer,'FIELD_1':'ADR_BDL','FIELD_2':'','FIELD_3':'','BND_KEEP':False,'DISSOLVED':'TEMPORARY_OUTPUT'})
            #saga_layer=saga['DISSOLVED']
            #Naprawa geometrii
            #a=processing.run("native:fixgeometries", {'INPUT':saga_layer,'OUTPUT':'TEMPORARY_OUTPUT'})
            #return a['OUTPUT']
            #layer = QgsVectorLayer(saga_layer, "naprawiona", "ogr")
            #return layer
#             #Naprawa geometrii
#             #a=processing.run("native:fixgeometries", {'INPUT':warstwa,'OUTPUT':'TEMPORARY_OUTPUT'})
#             #va=a['OUTPUT']
#             va=warstwa
#             #dociąganie punktów
#             b=processing.run("native:snappointstogrid", {'INPUT':va,'HSPACING':1e-05,'VSPACING':1e-05,'ZSPACING':0,'MSPACING':0,'OUTPUT':'TEMPORARY_OUTPUT'})
#             vb=b['OUTPUT']
#             vb.startEditing()
#             [vb.changeAttributeValue(feature.id(),feature.fieldNameIndex('ADR_BDL'),'{}    -'.format(feature['ADR_BDL'][0:18])) for feature in vb.getFeatures()]
#             vb.commitChanges()
#             #[feature.setAttribute('ADR_BDL','{}    -'.format(feature['ADR_BDL'][0:18])) for feature in vb.getFeatures()]
#             #agregacja
#             #collect_layer=processing.run("saga:polygondissolvebyattribute", {'POLYGONS':vb,'FIELD_1':'ADR_BDL','FIELD_2':'','FIELD_3':'','BND_KEEP':False,'DISSOLVED':'TEMPORARY_OUTPUT'})
#             #w=collect_layer['DISSOLVED']
#             #vlayer = QgsVectorLayer(w, "naprawiona", "ogr")
#             
#             #Ponowna naprawa geometrii
#             #a=processing.run("native:fixgeometries", {'INPUT':vlayer,'OUTPUT':'TEMPORARY_OUTPUT'})
#             #va=a['OUTPUT']
#             #Rozbicie multipolygon na polygon
#             #single_parts=processing.run("native:multiparttosingleparts", {'INPUT':va,'OUTPUT':'TEMPORARY_OUTPUT'})
#             #sl=single_parts['OUTPUT']
#             #Nałożenie bufora
#             sl=vb
#             buffer=processing.run("native:buffer", {'INPUT':sl,'DISTANCE':0.00002,'SEGMENTS':5,'END_CAP_STYLE':2,'JOIN_STYLE':1,'MITER_LIMIT':2,'DISSOLVE':False,'OUTPUT':'TEMPORARY_OUTPUT'})
#             bl=buffer['OUTPUT']
#             #Agregacja bufora 
#             disolve=processing.run("native:dissolve", {'INPUT':bl,'FIELD':['ADR_BDL'],'OUTPUT':'TEMPORARY_OUTPUT'})
#             return disolve['OUTPUT']
#             #Koniec naprawy warstwy
        except Exception as e:
            raise e